package com.ruoyi.doubledefense.domain;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.ruoyi.common.core.domain.TreeSelect;
import com.ruoyi.common.core.domain.entity.SysDept;
import com.ruoyi.common.core.domain.entity.SysMenu;
import com.ruoyi.common.core.domain.model.SysUserSimple;

import java.io.Serializable;
import java.util.List;
import java.util.stream.Collectors;

/**
 * Treeselect树结构实体类
 *
 * @author ruoyi
 */
public class ContractorTreeSelect implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 节点ID
     */
    private Long id;

    /**
     * 节点名称
     */
    private String label;

    /**
     * 子节点
     */
    @JsonInclude(JsonInclude.Include.NON_EMPTY)
    private List<ContractorTreeSelect> children;
    /**
     * 部门下用户列表
     **/
    private List<Contractor.UserSimple> sysUsers;

    public List<Contractor.UserSimple> getSysUsers() {
        return sysUsers;
    }

    public void setSysUsers(List<Contractor.UserSimple> sysUsers) {
        this.sysUsers = sysUsers;
    }

    public ContractorTreeSelect() {

    }

    /**
     * @param contractor 承包商
     */
    public ContractorTreeSelect(Contractor contractor) {
        this.id = contractor.getId();
        this.label = contractor.getCompanyName();
        this.children = contractor.getChildren().stream().map(ContractorTreeSelect::new).collect(Collectors.toList());
        this.sysUsers = contractor.getSysUserList();
    }


//    public TreeSelect(SysDept dept)
//    {
//        this.id = dept.getDeptId();
//        this.label = dept.getDeptName();
//        this.children = dept.getChildren().stream().map(TreeSelect::new).collect(Collectors.toList());
//        this.sysUsers = dept.getSysUserList();
//    }

//    public TreeSelect(SysMenu menu)
//    {
//        this.id = menu.getMenuId();
//        this.label = menu.getMenuName();
//        this.children = menu.getChildren().stream().map(TreeSelect::new).collect(Collectors.toList());
//    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public List<ContractorTreeSelect> getChildren() {
        return children;
    }

    public void setChildren(List<ContractorTreeSelect> children) {
        this.children = children;
    }

}
